!!
 Apply gravity to a ball.

 This program demonstrates
 movement for hBasic v5.00+

 - v1.00 -humpty: May-2024
   Uses hBasic's built-in motion
!!

GR.OPEN "black", 1,1 % <color>,bar,portrait
gr.color "white"
gr.screen sw,sh
m = min (sw,sh)

startx = sw/2 : starty = sh/2
radius = m/10

again:      % app loop
damp = 1            % damping 1=none, 0=max
pixPerM = m         % pixels per meter
acc = 9.8*pixPerM   % gravity

speed = 1       % start speed (don't use 0)
bdir = 90       % down
if oc=0 then gr.circle oc,startx,starty,radius
gr.modify oc, "x",startx, "y",starty
gr.modify oc, "dir",bdir    % down

gosub release       % ask user to tap

last = clock()      % needed for acceleration

GR.MOTION.MARK      % move from now
while 1      % motion loop
 gr.render
 GR.MOTION

 gr.get.value ot,"x",x,"speed",s    % check text
 if s>0 & x>sw then gr.modify ot,"speed",0 % stop text

 gr.get.value oc,"y",y      % check circle
 if (y+radius>sh) | (speed=0)   % bottom or top
    bdir = 360-bdir             % change direction
    gr.modify oc, "dir",bdir
    acc *= -1                   % negate acceleration
    if  acc<0 then              % if bounce up
        speed *= damp           % lose speed on bounce
        if damp>0 then damp -= 0.1
        if speed < m/5 then w_r.break   % don't bounce forever
        gr.modify oc,"y",sh-radius  % start from bottom
    else
        speed=1     % going down
    endif
    last = clock()  % restart timing
    w_r.continue
 endif 

 now=clock()        % apply acceleration
 dt = (now-last)/1000 : last=now
 ds = dt * acc
 speed += ds        % speed cannot be negative
 if speed < 0 then speed = 0
 gr.modify oc, "speed",speed
repeat

pause 1000
goto again      % loop forever
END

onbackkey:
 GR.CLOSE
end
release:
    if ot=0             % create text if needed
     gr.text.size radius/1.5
     gr.text.draw ot,0,0,"Tap to Drop"
    endif
    gr.modify ot, "x",startx,"y",starty-radius*2
    gr.modify ot, "speed",m     % pixels/s
    gr.render           % show it & wait for touch
    do : gr.touch tch,x,y : until tch
    do : gr.touch tch,x,y : until !tch
return
end
